petsc-3.12.1 2019-10-22
Report Typos and Errors

# PCLU

Uses a direct solver, based on LU factorization, as a preconditioner

### Options Database Keys

| -pc_factor_reuse_ordering | - Activate PCFactorSetReuseOrdering()
| -pc_factor_mat_solver_type | - Actives PCFactorSetMatSolverType() to choose the direct solver, like superlu
| -pc_factor_reuse_fill | - Activates PCFactorSetReuseFill()
| -pc_factor_fill <fill> | - Sets fill amount
| -pc_factor_in_place | - Activates in-place factorization
| -pc_factor_mat_ordering_type <nd,rcm,...> | - Sets ordering routine
| -pc_factor_pivot_in_blocks <true,false> | - allow pivoting within the small blocks during factorization (may increase stability of factorization.
| -pc_factor_shift_type <shifttype> | - Sets shift type or PETSC_DECIDE for the default; use '-help' for a list of available types
| -pc_factor_shift_amount <shiftamount> | - Sets shift amount or PETSC_DECIDE for the default
| -pc_factor_nonzeros_along_diagonal | - permutes the rows and columns to try to put nonzero value along the diagonal.

### Notes

Not all options work for all matrix formats Run with -help to see additional options for particular matrix formats or factorization algorithms

### Notes

Usually this will compute an "exact" solution in one iteration and does not need a Krylov method (i.e. you can use -ksp_type preonly, or KSPSetType(ksp,KSPPREONLY) for the Krylov method

### See Also

PCCreate(), PCSetType(), PCType (for list of available types), PC,
PCILU, PCCHOLESKY, PCICC, PCFactorSetReuseOrdering(), PCFactorSetReuseFill(), PCFactorGetMatrix(), PCFactorSetFill(), PCFactorSetUseInPlace(), PCFactorSetMatOrderingType(), PCFactorSetColumnPivot(), PCFactorSetPivotingInBlocks(),PCFactorSetShiftType(),PCFactorSetShiftAmount() PCFactorReorderForNonzeroDiagonal()

### Level

beginner

### Location

src/ksp/pc/impls/factor/lu/lu.c

### Examples

src/ksp/ksp/examples/tutorials/ex13.c.html
src/ksp/ksp/examples/tutorials/ex52.c.html
src/ksp/ksp/examples/tutorials/ex53.c.html
src/ksp/ksp/examples/tutorials/ex68.c.html
src/ksp/ksp/examples/tutorials/ex69.c.html
src/ksp/ksp/examples/tutorials/ex13f90.F90.html
src/ksp/ksp/examples/tutorials/ex52f.F90.html
src/ksp/ksp/examples/tutorials/ex61f.F90.html
src/tao/constrained/examples/tutorials/maros.c.html
src/tao/constrained/examples/tutorials/toy.c.html
src/tao/constrained/examples/tutorials/toyf.F90.html
Index of all PC routines
Table of Contents for all manual pages
Index of all manual pages